package service

import (
	"context"
	"fmt"
	push "gitea.timerzz.com/kedaya_haitao/pusher/kitex_gen/push"
	"gitea.timerzz.com/kedaya_haitao/pusher/pushers"
)

type PushService struct {
	ctx context.Context
} // NewPushService new PushService
func NewPushService(ctx context.Context) *PushService {
	return &PushService{ctx: ctx}
}

// Run create note info
func (s *PushService) Run(req *push.PushReq) (resp *push.Resp, err error) {
	// Finish your business logic.
	if len(req.Ids) == 0 {
		return nil, fmt.Errorf("缺少id")
	}
	resp = push.NewResp()
	err = pushers.Push(s.ctx, req.Ids, req.Title, req.Content)
	if err != nil {
		resp.Code = 100
		resp.Msg = err.Error()
	}
	return
}
