package pusher

import (
	"context"
	config "gitea.timerzz.com/kedaya_haitao/pusher/kitex_gen/config"
	push "gitea.timerzz.com/kedaya_haitao/pusher/kitex_gen/push"
	"github.com/cloudwego/kitex/client/callopt"
	"github.com/cloudwego/kitex/pkg/klog"
)

func Push(ctx context.Context, req *push.PushReq, callOptions ...callopt.Option) (resp *push.Resp, err error) {
	resp, err = defaultClient.Push(ctx, req, callOptions...)
	if err != nil {
		klog.CtxErrorf(ctx, "Push call failed,err =%+v", err)
		return nil, err
	}
	return resp, nil
}

func Add(ctx context.Context, req *config.PusherConfig, callOptions ...callopt.Option) (resp *push.Resp, err error) {
	resp, err = defaultClient.Add(ctx, req, callOptions...)
	if err != nil {
		klog.CtxErrorf(ctx, "Add call failed,err =%+v", err)
		return nil, err
	}
	return resp, nil
}

func List(ctx context.Context, req *push.ListPusherRequest, callOptions ...callopt.Option) (resp *push.ListPusherResponse, err error) {
	resp, err = defaultClient.List(ctx, req, callOptions...)
	if err != nil {
		klog.CtxErrorf(ctx, "List call failed,err =%+v", err)
		return nil, err
	}
	return resp, nil
}

func GetPusherOptions(ctx context.Context, callOptions ...callopt.Option) (resp *push.GetPusherOptionsResponse, err error) {
	resp, err = defaultClient.GetPusherOptions(ctx, callOptions...)
	if err != nil {
		klog.CtxErrorf(ctx, "GetPusherOptions call failed,err =%+v", err)
		return nil, err
	}
	return resp, nil
}
